//-------------------------------------------------------------
//
//   Greg's Blogging - Base class for blog sending threads
//
//-------------------------------------------------------------

package gcewing.blogging;

abstract class BlogThread implements Runnable {

	String subject;
	Thread thread;
	public boolean complete = false;
	public Exception error = null;

	public BlogThread(String subject) {
		this.subject = subject;
	}
	
	void start() {
		thread = new Thread(this);
		complete = false;
		error = null;
		thread.start();
	}
	
	public boolean hasFailed() {
		return error != null;
	}
	
	void reportError(String prefix, Exception e) {
		error = e;
		GregsBlogging.logError(prefix + ": " + e.getMessage());
	}

}
