//------------------------------------------------------
//
//   Greg's Blogging Mod - Main Class
//
//------------------------------------------------------

package gcewing.blogging;

import java.io.*;
import java.util.*;
//import java.util.logging.Level;
import org.apache.logging.log4j.Level;

import net.minecraft.client.gui.*;

import cpw.mods.fml.common.*;
import cpw.mods.fml.common.event.*;
import cpw.mods.fml.common.eventhandler.*;
import cpw.mods.fml.common.network.*;
import cpw.mods.fml.common.gameevent.*;
import cpw.mods.fml.common.gameevent.TickEvent.PlayerTickEvent;
import cpw.mods.fml.common.registry.*;
import cpw.mods.fml.client.FMLClientHandler;
import cpw.mods.fml.relauncher.*;
import net.minecraftforge.common.*;

import net.minecraftforge.event.*;
import net.minecraftforge.event.world.WorldEvent;

//import org.json.simple.*;
//import org.json.simple.parser.*;

import gcewing.blogging.GuiBlog.SendState;

@Mod(modid = Info.modID, name = Info.modName, version = Info.versionNumber,
	acceptableRemoteVersions = Info.versionBounds)

public class GregsBlogging extends BaseMod /*implements ITickHandler*/ {
	
	public static GregsBlogging mod;
	
	public GregsBlogging() {
		super();
		mod = this;
		FMLCommonHandler.instance().bus().register(this);
	}

	@Mod.EventHandler
	public void preInit(FMLPreInitializationEvent e) {
		super.preInit(e);
	}
	
	@Mod.EventHandler
	public void init(FMLInitializationEvent e) {
		super.init(e);
	}
	
	@Mod.EventHandler
	public void postInit(FMLPostInitializationEvent e) {
		SMTP.configure(config);
		Wordpress.configure(config);
		super.postInit(e);
	}

	@Override
	BaseModClient initClient() {
		return new GregsBloggingClient(this);
	}
	
	@Override
	void loadConfig() {
		//System.out.printf("GregsBlogging: Original config path: %s\n", cfgFile);
		File cfgDir = cfgFile.getParentFile().getParentFile();
		//System.out.printf("GregsBlogging: Config directory: %s\n", cfgDir);
		String cfgName = cfgFile.getName();
		//System.out.printf("GregsBlogging: Config name: %s\n", cfgName);
		cfgFile = new File(cfgDir, cfgName);
		//System.out.printf("GregsBlogging: Config path: %s\n", cfgFile);
		createConfig();
		super.loadConfig();
	}

	void createConfig() {
		try {
			if (cfgFile.createNewFile()) {
				//System.out.printf("GregsBlogging: Setting permissions on config file\n");
				cfgFile.setReadable(false, false);
				cfgFile.setReadable(true, true); // readable by owner only
			}
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
	
//	@Override
//	void registerOther() {
//		TickRegistry.registerTickHandler(this, Side.CLIENT);
//	}

	@SubscribeEvent
	public void onPlayerTickEvent(PlayerTickEvent e) {
		//System.out.printf("GregsBlogging.onPlayerTickEvent\n");
		switch (e.phase) {
			case START:
				tickStart();
				break;
		}
}		

//	@Override
	public void tickStart(/*EnumSet<TickType> type, Object... tickData*/) {
		//System.out.printf("GregsBlogging: tickStart\n");
		Chat.tick();
	}
	
//	@Override
//	public void tickEnd(EnumSet<TickType> type, Object... tickData) {
//	}
//	
//	@Override
//	public EnumSet<TickType> ticks() {
//		return EnumSet.of(TickType.PLAYER);
//	}
//	
//	@Override
//	public String getLabel() {
//		return "Greg's Blogging";
//	}

	@SubscribeEvent
	public void onDimensionLoad(WorldEvent.Load e) {
		// Workaround for WorldInfo.getWorldName() not working on client side. Captures
		// the world name when the integrated server loads a world in single player.
		// For the multiplayer case, see GuiBlog.updateTitle().
		String name = e.world.getWorldInfo().getWorldName();
		System.out.printf("GregsBlogging: World loaded: %s %s\n", e.world, name);
		if (!e.world.isRemote)
			GuiBlog.setWorldName(name);
	}
	
	public static void logError(Exception e) {
		logError(e.toString());
	}
	
	public static void logError(String format, Object... args) {
		String mess = String.format(format, args);
		FMLLog.log(Level.ERROR, "GregsBlogging: " + mess);
		Chat.print(mess);
	}

}
