//------------------------------------------------------
//
//   Greg's Blogging - Key Binding Manager
//
//------------------------------------------------------

package gcewing.blogging;

import java.util.*;
import net.minecraft.client.settings.*;
import cpw.mods.fml.client.registry.*;
import cpw.mods.fml.common.*;
import cpw.mods.fml.common.eventhandler.*;
import cpw.mods.fml.common.gameevent.TickEvent.ClientTickEvent;

public class KeyBindings {

	BaseMod mod;
	List<KeyHandlerBinding> bindings = new ArrayList<KeyHandlerBinding>();
	
	public void registerKey(String name, int keyCode, String category, IKeyHandler handler) {
		String id = String.format("key.%s.%s.name", mod.assetKey, name);
		KeyHandlerBinding b = new KeyHandlerBinding(id, keyCode, category, handler);
		bindings.add(b);
		ClientRegistry.registerKeyBinding(b);
	}
	
	public KeyBindings(BaseMod mod) {
		this.mod = mod;
		FMLCommonHandler.instance().bus().register(this);
	}
	
	@SubscribeEvent
	public void onClientTickEvent(ClientTickEvent e) {
		switch (e.phase) {
			case START:
				tick();
				break;
		}
	}		

	void tick() {
		for (KeyHandlerBinding b : bindings)
			if (b.isPressed())
				b.handler.keyDown();
	}

}

//--------------------------------------------------------------------------------------------------

class KeyHandlerBinding extends KeyBinding {

	public IKeyHandler handler;

	KeyHandlerBinding(String id, int keyCode, String category, IKeyHandler handler) {
		super(id, keyCode, category);
		this.handler = handler;
	}

}
